function LJService(){
	this.onError = null;
	this.onSuccess = null;
	
	this.getChallengeCallback = null;
	this.auth_challenge = null;
	this.auth_response = null;
	
	this.url = "http://www.livejournal.com/interface/flat";
	this.mode = null;
	
	this.username = null;
	this.password = null;
}

LJService.prototype._getChallenge=function(){
	this.mode = "getchallenge";
	data = "mode=" + this.mode;
	this._processRequest(this.url, data, true);
}


LJService.prototype._processRequest = function (url, data, synchr)
{
	var self = this;
	req = this._createXMLHttpRequest();
	req.onreadystatechange = function(){
		self._processStateChange();
	}
	req.open("POST", url, synchr);
	req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	req.setRequestHeader("Content-length", data.length);
	req.send(data);
}

LJService.prototype._processStateChange = function (){
	// Request states are 0 through 4, where 4 equals complete
	if (req.readyState == 4)
		{
		// Server returns numeric code 200 for "OK".
		if (req.status == 200)
			{
				this._processResponse( req.responseText );	
			}
		}
}

LJService.prototype._processResponse = function(response){
	
	parsedResponce = this._parseResponse(response, this.mode);
	
	//alert(response);
	if (parsedResponce != "undefined" && parsedResponce["success"] == "OK") {
		if (parsedResponce["mode"] == "getchallenge") {
			this.auth_challenge = parsedResponce["challenge"];
			md5pass = hex_md5(this.password);
			md5pass = this.auth_challenge + md5pass;
			this.auth_response = hex_md5(md5pass);
			this.getChallengeCallback();
		}else{
			
			this.onSuccess(parsedResponce);
		}
	}else{
		//alert("goto onError = " + this.onError );
		this.onError(parsedResponce["errmsg"]);
	}
}

LJService.prototype._parseResponse = function(response, mode){
	//alert("response="+response);
	splittedResponse = response.split("\n");
	
			
	var result = [];
	result["mode"] = mode;
	for (i = 0; i < splittedResponse.length-1; i+=2 )
			{
				if( mode == "getevents" ){
					//alert(""+splittedResponse[ i ]+"="+splittedResponse[ i+1 ]);
				}
				
				result[splittedResponse[i]] = splittedResponse[i+1];
				
			}
	
			
	return result;
}

LJService.prototype._createXMLHttpRequest = function () {
	var req = null;
	try {
	req = new XMLHttpRequest();
	if (typeof req.overrideMimeType != "undefined") {
	  req.overrideMimeType("text/xml");
	}
	} catch (ex) {
	req = null;
	}
	return req;
}

LJService.prototype.setCredentials = function( username, password ){
	this.username = username;
	this.password = password;
}

LJService.prototype.setCallbacks = function( onSuccess, onError ){
	this.onSuccess = onSuccess;
	this.onError = onError;
}

LJService.prototype.getEvents=function(prefersubject, noprops, selecttype, lineendings, param){
	this.getChallengeCallback = function(){
		this.mode = "getevents";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		data += "&prefersubject=" + prefersubject + "&noprops=" + noprops + "&selecttype=" + selecttype + "&lineendings" + lineendings;  
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.getFriends=function(param){
	this.getChallengeCallback = function(){
		this.mode = "getfriends";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.postEvent = function(lineendings, year, mon, day, hour, min, event, subject, param){
	this.getChallengeCallback = function(){
		this.mode = "postevent";
		data = "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		
		data += "&lineendings=" + lineendings + "&year=" + year + "&mon=" + mon + "&day=" + day + "&hour=" + hour + "&min=" + min + "&event=" + event + "&subject=" + subject;
		for (name in param) {
			data += "&" + name + "=" + param[name];
		}
		//alert("posting");
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.login=function(param){
	this.getChallengeCallback = function(){
		//alert("challenge returned");
		this.mode = "login";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.checkFriends=function(param){
	this.getChallengeCallback = function(){
		this.mode = "checkfriends";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.friendOf=function(param){
	this.getChallengeCallback = function(){
		this.mode = "friendof";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.getUserTags=function(param){
	this.getChallengeCallback = function(){
		this.mode = "getusertags";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.syncItems=function(param){
	this.getChallengeCallback = function(){
		this.mode = "syncitems";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.consoleCommand=function(param){
	this.getChallengeCallback = function(){
		this.mode = "consolecommand";
		data =  "mode=" + this.mode;
		data += "&auth_method=challenge&auth_challenge=" + this.auth_challenge + "&auth_response=" + this.auth_response + "&user=" + this.username;
		for(name in param)
			{
				data += "&" + name + "=" + param[name]; 
			}
		this._processRequest(this.url, data, true);
	}
	this._getChallenge();
}

LJService.prototype.showProgress = function( show ) {
	if (show == null) 
		show = true;

	Helper.show( "loader_popup", show );			
}