
function LocationHandler(){
	this.serviceObj = null; 
}

LocationHandler.prototype.getLocation = function () {
    
	var serviceObj = null;
	
    
    try {
        serviceObj = device.getServiceObject("Service.Location", "ILocation");
    } catch (ex) {
        
        return;
    }
    
    // The user cancelled the service object initialization
    if (serviceObj.ILocation == null) {
		
        return;
    }

    // Specify that location information need not be guaranteed. This helps in
    // that the widget doesn't need to wait for that information possibly
    // indefinitely.
    var updateOptions = new Object();
    updateOptions.PartialUpdates = true;

    // Initialize the criteria for the GetLocation call
    var criteria = new Object();
    criteria.LocationInformationClass = "GenericLocationInfo";
    criteria.Updateoptions = updateOptions;
   
    try {
		
        var result = serviceObj.ILocation.GetLocation(criteria, this.locationCallback);
    } catch (ex) {
        
        return;
    }
       
}



// Called when Location received
LocationHandler.prototype.locationCallback = function(transId, eventCode, result){
    // On error situation, display the error message
   
    
    if (eventCode == 4) {
        alert(StringTable.Code.GPSFail); 
        return;
    }
    
    var latitude = result.ReturnValue.Latitude;
    var longitude = result.ReturnValue.Longitude;

    
    if (!isNaN(latitude) || !isNaN(longitude)) {
		
		latitude = latitude.toFixed(6);
		longitude = longitude.toFixed(6);
		
        var lat_letter = "N";
        var long_letter = "E";
		
        if (latitude < 0) {
            latitude = latitude * (-1);
            lat_letter = "S";
        }
        
        if (longitude < 0) {
            longitude = longitude * (-1);
            long_letter = "W";
        }
        
        var coords = latitude + lat_letter + " " + longitude + long_letter;
        
        document.getElementById("location_text").value = coords;
//        alert(coords);
        postScreen.coordReceived = true;
        
    }
    
}


// Cancel location request
LocationHandler.prototype.stop  = function () {
        
    // Stop the Trace
    var cancelCriteria = new Object();
    cancelCriteria.CancelRequestType = "GetLocCancel";
    var result = this.serviceObj.ILocation.CancelNotification(cancelCriteria);
}