	
function Menu() {
	var self = this;	
	// Check the screen size we are running on.
	
	var closeLoaderButton = document.getElementById( "closeLoaderButton" );
	closeLoaderButton.onclick = function() {
		 ljservice.showProgress(false);
		 ljservice.setCallbacks( function(){}, function(){} );
	};
	
	if ( Helper.isLargeScreen() ) {
		// Handle clicks from menu buttons to activate the relevant pages. 
		var updateButton = document.getElementById( "button_update" );
		updateButton.onclick = function() {
			 self.activate( Menu.POST_SCREEN );
		};
		var searchButton = document.getElementById( "button_search" );
		searchButton.onclick = function() {
			 self.activate( Menu.FRIEND_FEED );
		};
		var settingsButton = document.getElementById( "button_settings" );
		settingsButton.onclick = function() {
			 self.activate( Menu.SETTINGS_SCREEN );
		};
		// Assign functionality to top bar buttons.
		var logoutButton = document.getElementById( "button_logout" );
		logoutButton.onclick = function() { widgetMenu.activate( Menu.LOGIN_SCREEN ); };
		var exitButton = document.getElementById( "button_exit" );
		exitButton.onclick = function() { window.close(); };
				
	} else {
		// Create phone's softmenu.
		this.miUpdateTwitter = new MenuItem( StringTable.Code.menuUpdateTwitter, 9000 );
		var miUpdate = new MenuItem( StringTable.Code.menuUpdate, 9001 );
		var miSearch = new MenuItem( StringTable.Code.menuSearch, 9002 );
		var miSettings = new MenuItem( StringTable.Code.menuSettings, 9003 );
		var miLogout = new MenuItem( StringTable.Code.menuLogout, 9004 );
	
	  	// Assign a callback function for the menu items
	  	this.miUpdateTwitter.onSelect = function () { postScreen.onUpdateClicked(); };
	  	miUpdate.onSelect = function () { self.activate( Menu.POST_SCREEN ); };
	  	miSearch.onSelect = function () { self.activate( Menu.FRIEND_FEED ); };
	  	miSettings.onSelect = function () { self.activate( Menu.SETTINGS_SCREEN ); };
		miLogout.onSelect = function () { widgetMenu.activate( Menu.LOGIN_SCREEN ); };
		
		// Add them to the top-level menu. Don't forget to dim out
		// the "Update Twitter" menu item since it is only shown on the
		// Update screen for faster navigation.
		this.miUpdateTwitter.setDimmed( true );
		menu.append( this.miUpdateTwitter );
		menu.append( miUpdate );
		menu.append( miSearch );
		menu.append( miSettings );		
		menu.append( miLogout );		
	}
	
}

Menu.prototype.activate = function( screenId ) {	
	widget.prepareForTransition( "fade" ); 
	//alert("Menu.activate."+screenId);
	// Don't display the widget menu on login screen.
	if ( Helper.isLargeScreen() ) {
		Helper.show( "menu_strip", screenId != Menu.LOGIN_SCREEN );	

		// Show login and logout buttons on the top bar. Do this only on large screens since on
		// small screens they are available from the softmenu.
		Helper.show( "button_logout", screenId != Menu.LOGIN_SCREEN );
		Helper.show( "button_exit", true );			
	} else {
		if ( screenId == Menu.LOGIN_SCREEN ) {
			menu.hideSoftkeys();
		} else {
			menu.showSoftkeys();
		}
		
		// Show the specific menu items only on pages they are
		// intended for.
		this.miUpdateTwitter.setDimmed( screenId != Menu.POST_SCREEN );
	}	

	// Show the desired screen.
	Helper.show( Menu.LOGIN_SCREEN, screenId == Menu.LOGIN_SCREEN );
	Helper.show( Menu.POST_SCREEN, screenId == Menu.POST_SCREEN );
	Helper.show( Menu.FRIEND_FEED, screenId == Menu.FRIEND_FEED );
	Helper.show( Menu.SETTINGS_SCREEN, screenId == Menu.SETTINGS_SCREEN );
	Helper.show( Menu.POST_VIEW, screenId == Menu.POST_VIEW );

			
	// On big screens, update the menu strip manually.
	if ( Helper.isLargeScreen() ) {
		// Activate the selected button.
		this._activateButton( screenId );
	}	
	
	// Known Issue: Below line doesn't work if the activation comes from widget's submenu.
	//              widget.performTransition();
	setTimeout ( "widget.performTransition();", 0 );

	//  Let the screen know it's being activated.
	if ( screenId == Menu.LOGIN_SCREEN ) {
		loginScreen.onActivated();
	} else if ( screenId == Menu.POST_SCREEN ) {
		postScreen.onActivated();
	} else if ( screenId == Menu.FRIEND_FEED ) {
		friendsScreen.onActivated();
	} else if ( screenId == Menu.SETTINGS_SCREEN ) {
		settingsScreen.onActivated();
	} else if ( screenId == Menu.POST_VIEW ){
		viewPostScreen.onActivated();
	}
	//alert("menu:"+this.activeScreen+":"+screenId);
	Menu.previousScreen = Menu.activeScreen; 	
	Menu.activeScreen = screenId;


	if ( Helper.isLargeScreen() &&( screenId == Menu.LOGIN_SCREEN || Menu.previousScreen == Menu.LOGIN_SCREEN ) ) {
		// Do a manual resize to update the different screen layout on the login
		// screen where the menu isn't shown. 
		resizeNormalView();
	}

}

Menu.prototype._activateButton = function( screenId ) {
	// Activate or deactivate menu buttons. Since the button is a composite of an
	// image and text (allows localization), we need to change the styling of the
	// button container (div) and not the link (a).
	Helper.activate( "button_container_update", screenId == Menu.POST_SCREEN );
	Helper.activate( "button_container_search", screenId == Menu.FRIEND_FEED );
	Helper.activate( "button_container_settings", screenId == Menu.SETTINGS_SCREEN );
}

Menu.activeScreen = "";
Menu.previousScreen = "";

Menu.LOGIN_SCREEN = "login";
Menu.SETTINGS_SCREEN = "settings";

Menu.FRIEND_FEED = "friend_feed";
Menu.POST_SCREEN = "post_screen";
Menu.POST_VIEW =  "view_post";
