/**
 * @author al.sidorenko
 */

function PostScreen() {
	// Get the update button element and assign an 'onclick' event to it.
	var self = this;
	var coordsRecieved = false;
	var updateButton = document.getElementById( "update_status_button" );
	updateButton.onclick = function() {
		 self.onUpdateClicked();
	};
	
	// Also update the remaining characters label on text changes.
	this.taStatus = document.getElementById( "status_message" );
	this.taSubject = document.getElementById( "subject" );
	this.taTags = document.getElementById( "tags" );
	this.taTags.value = "nokia_widget,";
	
	this.cbGpsSwitch = document.getElementById("gps_checkbox");
	this.cbGpsSwitch.onclick = this.handleGPSCheckBox;

}

PostScreen.prototype.onActivated = function(){
	document.getElementById("location_text").value = "";
	document.getElementById("status_message").value = "";
	document.getElementById("subject").value = "";
	document.getElementById("tags").value = "nokia_widget,";
}


PostScreen.prototype.onUpdateClicked = function() {
	var event = this.taStatus.value;
	var subject = this.taSubject.value;
	var tags = this.taTags.value;
	
	if (event == "" || subject == "") {
		alert(StringTable.Code.fillSubjectAndText); 
		
	}
	else {
		ljservice.showProgress();
		ljservice.setCallbacks(this.onSuccess, this.onError);
		var param_postEvent = [];
		param_postEvent["ver"] = "1";
		param_postEvent["prop_taglist"] = this._parseTags();
		if(document.getElementById("gps_checkbox").checked){
			if(this.coordsRecieved)
			{
				param_postEvent["prop_current_coords"] = document.getElementById("location_text").value;
			}
		}
		else{
			if(document.getElementById("location_text").value != "")
			param_postEvent["prop_current_location"] = document.getElementById("location_text").value;
		}
		
		
		
		curdate = new Date();
		ms = curdate.getTime();
		curdate.setTime(ms);	 
		year = curdate.getFullYear();
		mon = curdate.getMonth() + 1;
		day = curdate.getDate();
		hour = curdate.getHours();
		min = curdate.getMinutes();
//		alert("day:"+day+" hour:"+hour+" min:"+min);
		ljservice.postEvent("unix", year, mon, day, hour, min, event, subject, 
							param_postEvent);
	}
}



PostScreen.prototype.onSuccess = function( responce ){
	ljservice.showProgress(false);
	alert(StringTable.Code.messagePosted);
	document.getElementById("location_text").value = "";
	document.getElementById("status_message").value = "";
	document.getElementById("subject").value = "";
	document.getElementById("tags").value = "nokia_widget,";
}

PostScreen.prototype.onError = function(msg){
	ljservice.showProgress(false);
	alert(msg);
}

PostScreen.prototype._parseTags = function( ){
	var rawtags = document.getElementById("tags").value; // space-separated tags
	return rawtags;	
}


PostScreen.prototype.handleGPSCheckBox = function(){
	this.cbGpsSwitch = document.getElementById("gps_checkbox");
	Helper.handleCustomControlClick( this.cbGpsSwitch );
	
	if(this.cbGpsSwitch.checked)
	{
		this.taLocation = document.getElementById("location_text");
		this.taLocation.value = StringTable.Code.locationLoadingLabel;
		this.taLocation.disabled = true;
		locationHandler.getLocation();
	}
	else
	{
		this.taLocation.disabled = false;
		LocationHandler.prototype.stop();
	}
}

