	
function SearchScreen() {
	// Get the update button element and assign an 'onclick' event to it.
	var self = this;
	var findButton = document.getElementById( "find_button" );
	findButton.onclick = function() {
		 self.onFindClicked();
	};
	
	this.tbFind = document.getElementById( "textbox_find" );
}

SearchScreen.prototype.onActivated = function() {
	// Add event listeners.
	var self = this;
	twitterService.onSuccess = function( response ) { self.onTwitterSearchResponse( response.results ) }
	twitterService.onError = function( status ) { self.onTwitterServiceError( status ) }
}

SearchScreen.prototype.onFindClicked = function() {
	// Start the search.
	twitterService.search( this.tbFind.value );
}

SearchScreen.prototype.onTwitterSearchResponse = function( response ) {
	var tweetsTable = document.getElementById( "search_tweets_table" );
	var html = Helper.createTableHeader( StringTable.Code.searchScreenCaption );

	// Fill in the table.
	for ( var i = 0; i < response.length; ++i ) {
		var tweet = response[i];
		
		html += Helper.createStatusRow( tweet.profile_image_url,
			tweet.from_user,
			tweet.text,
			new Date( tweet.created_at ).toLocaleString() );			
	}
	
	tweetsTable.innerHTML = html;
}

SearchScreen.prototype.onTwitterServiceError = function( status ) {
	alert( StringTable.Code.searchDataError + " (" + status + ")" );
}

