	
function SettingsScreen() {
	// Get the Save button element and assign an 'onclick' event to it.
	var self = this;
	var saveButton = document.getElementById( "save_button" );
	saveButton.onclick = function() {
		 self.onSaveClicked();
	};
	
	// Get all the UI elements that we can interact with.
	this.dropRefresh = document.getElementById( "drop_refresh" );
	this.cbRememberMe = document.getElementById( "setings_remember_me" );
	// Click handling via styles for touch screens.
	this.cbRememberMe.onclick = function() {
		Helper.handleCustomControlClick( self.cbRememberMe );
	};		
	this.radioPosting = document.getElementById( "radio_posting" );
	// Click handling via styles for touch screens.
	this.radioPosting.onclick = function() {
		Helper.handleCustomControlClick( self.radioPosting );
		Helper.handleCustomControlClick( self.radioSearch );
	};		
	this.radioSearch = document.getElementById( "radio_search" );
	// Click handling via styles for touch screens.
	this.radioSearch.onclick = function() {
		Helper.handleCustomControlClick( self.radioPosting );
		Helper.handleCustomControlClick( self.radioSearch );
	};		
}

SettingsScreen.prototype.setRefreshDropDown = function( refresh ) {
	if ( refresh != null ) {
		for (var i = 0; i < this.dropRefresh.options.length; ++i) {
			var value = this.dropRefresh.options[i].value;
			if ( value == refresh ) {
				this.dropRefresh.selectedIndex = i;
				break;
			}
		}
	}
}

SettingsScreen.prototype.onSaveClicked = function() {
	// Save the data to the storage.
	widget.setPreferenceForKey( this.dropRefresh.options[this.dropRefresh.selectedIndex].value, SettingsScreen.KEY_REFRESH );
	widget.setPreferenceForKey( this.cbRememberMe.checked.toString(), SettingsScreen.KEY_REMEMBER_ME );
	widget.setPreferenceForKey( this.radioPosting.checked ? SettingsScreen.POST_PAGE : SettingsScreen.SEARCH_PAGE, SettingsScreen.KEY_STARTUP_PAGE );
	
	// Notify user that the changes were saved.
	alert( StringTable.Code.settingsSavedAlert );
}

SettingsScreen.prototype.onActivated = function() {
	// Load the stored settings and set the UI. Do this when the screen is activated
	// so that it reflects changes from the login page.
	var refresh = widget.preferenceForKey( SettingsScreen.KEY_REFRESH );
	var rememberMe = widget.preferenceForKey( SettingsScreen.KEY_REMEMBER_ME );
	var startupPage = widget.preferenceForKey( SettingsScreen.KEY_STARTUP_PAGE );

	// Assign to UI controls.
	this.setRefreshDropDown( refresh );
	this.cbRememberMe.checked = (rememberMe == "true");
	// We need to update our custom checkbox to reflect the checked state manually.
	Helper.handleCustomControlClick( this.cbRememberMe );

	this.radioPosting.checked = true;
	if (startupPage == SettingsScreen.SEARCH_PAGE) {
		this.radioSearch.checked = true;
	}
	// We need to update our custom checkbox to reflect the checked state manually.
	Helper.handleCustomControlClick( this.radioPosting );
	Helper.handleCustomControlClick( this.radioSearch );
}

SettingsScreen.KEY_REFRESH = "net.em.refresh";
SettingsScreen.KEY_REMEMBER_ME = LoginScreen.KEY_REMEMBER_ME;
SettingsScreen.KEY_STARTUP_PAGE = "net.em.startup";

SettingsScreen.POST_PAGE = "post_screen";
SettingsScreen.SEARCH_PAGE = "friend_feed";
