
function TwitterService() {
	this.httpRequest = null;
	
	this.onError = null;
	this.onSuccess = null;	
}	

TwitterService.prototype.setCredentials = function( username, password ){
	this.username = username;
	this.password = password;
}

TwitterService.prototype._doRequest = function( url, type ) {
	this.showProgress();

    this.httpReq = new XMLHttpRequest();
	
    var self = this;
    this.httpReq.onreadystatechange = function() { 
		self._readyStateChanged(); 
	};

	// Default to GET HTTP request if none is provided.
	if ( type == null ) {
		type = "GET";
	}
	
    this.httpReq.open( type, url, true );			
    this.httpReq.send( "" );
}

TwitterService.prototype._readyStateChanged = function() {
    // Complete request?
    if ( this.httpReq.readyState == 4 ) {
        // Attempt to get response status.
        var responseStatus = null;
        try {
            responseStatus = this.httpReq.status;
        } 
		catch (noStatusException) {
			// Alert the user that something has gone wrong.
			alert( StringTable.Code.twitterServiceNoStatusAlert );
		}
		
		// Check response status.
		if ( responseStatus == 200 ) {
			var res = null;
			
			// If response doesn't contain xml, forward text.
			res = this.httpReq.responseText;

			// Not needed anymore.
			this.httpReq = null;
			this.handleSuccessResponse.call( this, res );
		} else {
			this.handleErrorResponse.call( this, responseStatus );
		}
    }
}

TwitterService.prototype.getTweetsForUser = function( username, count ) {
	if (username == null) {
		username = this.username;
	}

	// Build URL and do the request.
	var url = "http://" + this.username + ":" + this.password + "@twitter.com/statuses/user_timeline/" + username + ".json?count=" + count;
	this._doRequest( url );
}

TwitterService.prototype.getFriendsTweets = function( count ) {
	// Build URL and do the request.
	var url = "http://" + this.username + ":" + this.password + "@twitter.com/statuses/friends_timeline.json?count=" + count;
	this._doRequest( url );
}

TwitterService.prototype.updateStatus = function( message ) {
	// Build URL and do the request.
	var url = "http://" + this.username + ":" + this.password + "@twitter.com/statuses/update.json?status=" + encodeURIComponent( message );
	this._doRequest( url, "POST" );
}

TwitterService.prototype.getPublicTweets = function( count ) {
	// Build URL and do the request.
	var url = "http://twitter.com/statuses/public_timeline.json?count=" + count;
	this._doRequest( url );
}

TwitterService.prototype.search = function( text ) {
	// Build URL and do the request.
	var url = "http://search.twitter.com/search.json?q=" + encodeURIComponent( text );
	this._doRequest( url );
}

TwitterService.prototype.cancel = function() {
	this.showProgress( false );
}
	
TwitterService.prototype.showProgress = function( show ) {
	if (show == null) 
		show = true;

	Helper.show( "loader_popup", show );			
}
			
TwitterService.prototype.handleSuccessResponse = function( arg ) {
	this.showProgress( false );

	// Eval the data.
	var response = eval( "(" + arg  + ")" );

    // Feed fetched and parsed successfully.
	if ( this.onSuccess )
    	this.onSuccess.call( this, response );	
}
	
TwitterService.prototype.handleErrorResponse = function( status ) {
	this.showProgress( false );

	if ( this.onError )
    	this.onError.call( this, status );
}
